#!/bin/sh
# Kino-Suche-Plugin    - by rich -
# Datenquelle:   www.heutekino.de
# Flexmenue:
#  ACTION=&Kino-Suche in ...,/var/plugins/kino_heute.sh SUCHE
#  ACTION=&*Kino-Suche in Berlin,/var/plugins/kino_heute.sh SUCHE "Berlin"
#  ACTION=&*Alle Kino-Neustarts anzeigen,/var/plugins/kino_heute.sh NEUE
#  INCLUDE=/var/tuxbox/config/kino_suche.conf
#
#######  Einstellungen  ################

tuxwetter=/var/plugins/tuxwet/tuxwetter
max_liste=100
timeout=20

########################################
VERSION="V 0.05"
FLEX_A="FONT=/share/fonts/micron_bold.ttf~>WIDTH=620~>HIGHT=510~>FONTSIZE=18~>LINESPP=20~>PAGING=1"
FLEX_E="COMMENT=Kino-Suche-Plugin  $VERSION ~t - by rich -~>COMMENT=Datenquelle:   www.heutekino.de~>ENDMENU"
kill_funktion() {
	kill $$
	killall msgbox
	msgbox size=32 timeout=7 refresh=2 title="Kino-Suche-Plugin" popup="~cTimeout:  Der Server ist nicht erreichbar !"
	exit 1
}
timeOut() {
	sleep $timeout && kill_funktion &
}
fehler_info() {
	[ "$TEXT" = 1 ] && TEXT="Fehler:   Der Server antwortet nicht !" || TEXT="Die Suche erbrachte kein Ergebnis."
	msgbox size=32 title="$FEHLER" msg="~c$TEXT"
}
kino_info() {
	[ -e /tmp/kino_detail.flx ] && DETAIL=flx || DETAIL=dat
	KINO_I=`sed -e 's/^COMMENT=~S\(.*\)/\1 /' /tmp/kino_detail.$DETAIL | sed '1s/^/'"$KINO_N"' \n/' | sed -e '{1s/.\{,65\} /~c~Y&\n~Y/g;2,$s/.\{,65\} /~c&\n/g}' | sed -e '{s/^~Y$/~s/;s/ *$//;/^$/d}' | sed -e '1,13!d'`
}
film_info() {
	timeOut
	wget -q -O /tmp/kino_film.htm "http://www.heutekino.de/$FILM_ID"
	kill $!
	FEHLER=Film-Information
	if [ -s /tmp/kino_film.htm ]; then
		F_BILD=`sed -n 's/.*\(FilmBild.php?id=[^"]*\).*/\1/p' /tmp/kino_film.htm | sed -e '1!d'`
		F_INFO=`sed -n '/section=filmliste&Film=/,/<\/td><\/tr><\/table>/p' /tmp/kino_film.htm | sed -e '{2,$s/<b>Genre:<\/b><\/div>/& /;2,$s/<tr><td>/\n/g;2,$s/<[^>]*>//g;1s/<\/div><br><br>/&~S\n/;1s/<[^>]*>/_/g;y/'\''//;1s/_*\([^_]*\)_*\([^_]*\)_*\([^_]*\)_*\([^_]*\)_*\([^_]*\).*/\1 \n~s \n\2 \n\3 \n\4 \n \n\5 \n~S /}' | sed -e '{1s/.\{,65\} /~Y&\n/g;2,$s/$/ /;2,$s/.\{,65\} /&\n/g}' | sed -e '{s/^ *//;s/ *$//;s/	//g;/^[^ -~]*$/d}' | sed -e '$s/\(.\{64,64\}\).*/\1.../'`
		F_INFO1="$(echo "$F_INFO" | sed -n '1,16p')~n~s"
		F_INFO2="$(echo "$F_INFO" | sed -n '17,32p')~n~s"
		if [ "$F_INFO2" != "~n~s" ]; then
			S_2="Seite  2"; SN=2
			F_INFO3="$(echo "$F_INFO" | sed -n '33,48p')~n~s"
			if [ "$F_INFO3" != "~n~s" ]; then
				S_3="Seite  3"; SN=3
				F_INFO4="$(echo "$F_INFO" | sed -n '49,64p')~n~s"
				if [ "$F_INFO4" != "~n~s" ]; then
					S_4="Seite  4"; SN=4
					F_INFO6="$(echo "$F_INFO" | sed -n '81s/..*/ .../p')"
					F_INFO5="$(echo "$F_INFO" | sed -n '65,80p')~F$F_INFO6~n~s"
					if [ "$F_INFO5" != "~F~n~s" ]; then
						S_5="Seite  5"; SN="5$F_INFO6"
					fi
				fi
			fi
		fi
		if [ "$F_INFO1" = "~n~s" -o "$F_INFO1" = "" ]; then
			 F_INFO1="~cEs ist keine Film-Information verf~ugbar."
		else
			if [ -e $tuxwetter -a -n "$F_BILD" ]; then
				BILD="Bild-Info"
			fi
		fi
		info_s1() {
			msgbox size=29 default=${DEF_T:-1} absolute=1 select="EXIT,$S_2,$BILD" title="Film-Information  1/${SN:-1}" msg="$F_INFO1"
			SEL_T=$?
			if [ $SEL_T = 3 ]; then
				timeOut
				wget -q -O /tmp/kino_bild.jpg "http://www.heutekino.de/$F_BILD"
				kill $!
				DEF_T=3
				if [ -s /tmp/kino_bild.jpg ]; then
					$tuxwetter PICTURE=Bild-Information,http://localhost/../../../../tmp/kino_bild.jpg
				else
					msgbox size=32 title="Bild-Information" msg="~cFehler:   Das Bild konnte nicht geladen werden."
				fi
				[ -e /tmp/kino_bild.jpg ] && rm /tmp/kino_bild.jpg
				info_s1
			fi
			if [ $SEL_T = 2 ]; then
				DEF_T=2
				msgbox size=29 default=2 absolute=1 select="EXIT,${S_3:-"Seite  1"}" title="Film-Information  2/$SN" msg="$F_INFO2"
				SEL_T=$?
				if [ $SEL_T = 2 ]; then
					if [ -n "$S_3" ]; then
						msgbox size=29 default=2 absolute=1 select="EXIT,${S_4:-"Seite  1"}" title="Film-Information  3/$SN" msg="$F_INFO3"
						SEL_T=$?
						if [ $SEL_T = 2 ]; then
							if [ -n "$S_4" ]; then
								msgbox size=29 default=2 absolute=1 select="EXIT,${S_5:-"Seite  1"}" title="Film-Information  4/$SN" msg="$F_INFO4"
								SEL_T=$?
								if [ $SEL_T = 2 ]; then
									if [ -n "$S_5" ]; then
										msgbox size=29 default=2 absolute=1 select="EXIT,Seite  1" title="Film-Information  5/$SN" msg="$F_INFO5"
										SEL_T=$?
										if [ $SEL_T = 2 ]; then
											info_s1
										fi
									else
										info_s1
									fi
								fi
							else
								info_s1
							fi
						fi
					else
						info_s1
					fi
				fi
			fi
		}
		info_s1
	else
		TEXT=1; fehler_info
	fi
	[ -e /tmp/kino_film.htm ] && rm /tmp/kino_film.htm
}
case $1 in
	SUCHE)
		[ -n "$3" ] && SUCH=Film
		if [ "$2" = "" ]; then
			if [ -s /tmp/kino_stadt.dat ]; then
				STADT=`cat /tmp/kino_stadt.dat`
			fi
			STADT=`input c=21 k=1 l='@@@@@@@@@@@@@@@@@@@@@' t='Bitte die Stadt eingeben.' d="${STADT:- }" | sed -e '{s/^$/_/;s/^ *//;s/ *$//}'`
			if [ "$STADT" = "_" ]; then
				exit 0
			fi
			echo "$STADT" > /tmp/kino_stadt.dat
			if [ "$STADT" = "" ]; then
				msgbox size=32 title="${SUCH:-Kino}-Suche in  ???" msg="~cFehler:   Bitte eine Stadt eingeben !"
				exit 0
			fi
		else
			STADT="$2"
		fi
		STADT_2=`echo "$STADT&Film=$3" | sed -e '{s/~A/'\'/g;s/~O/'\'/g;s/~U/'\'/g;s/~a/'\'/g;s/~o/'\'/g;s/~u/'\'/g;s/~z/'\'/g;s/~d/'\'/g;s/ /%20/g}'`
		timeOut
		wget -q -O /tmp/kino_heute.htm "http://www.heutekino.de/index.php?section=filmliste&size=$max_liste&Stadt=$STADT_2"
		kill $!
		FEHLER="${SUCH:-Kino}-Suche in ..."
		if [ -s /tmp/kino_heute.htm ]; then
			echo "$FLEX_A~>MENU=${SUCH:-Kino}-Suche in $STADT" | sed -e 's/~>/\n/g' > /tmp/kino_heute.flx
			sed -n '/<a class = .ulink.>/,/lign=.top. colspan=.*Uhr.*<\/td>$/p' /tmp/kino_heute.htm | sed -e '{/^<tr>$/d;s/index.php?section[^"]*/>&_</;s/<[^>]*>/_/g;y/'\''//}' | sed 'N;s/\n//' | sed 'NN;s/\n//' | sed 'N;s/\n//' | sed -e 's|_*[^_]*_\([^_]*\)_*\([^_]*\)__\([^_]*\)_*\([^_]*\)__\([^_]*\)_*\([^_]*\)__\([^_]*\)_*[^_]*_*\([^_]*\).*|COMMENT=\1~T120Zeiten:  \8\nACTION=\&Kino:~T105'\''\5  -  \3'\'','$0' KINO '\''\5'\'' \"\4\" '\''\3'\''\nACTION=\&Film:~T105'\''\7'\'','$0' FILM '\''\7'\'' \"\6\"\nCOMMENT=*|;s/\( \".*=showkino[^ ]*\)&Film=[^&]*/\1/' >> /tmp/kino_heute.flx
			echo "$FLEX_E" | sed -e 's/~>/\n/g' >> /tmp/kino_heute.flx
			if [ $(grep -c '^ACTION=' /tmp/kino_heute.flx) -le 0 ]; then
				fehler_info
				[ -e /tmp/kino_heute.flx ] && rm /tmp/kino_heute.flx
			else
				shellexec /tmp/kino_heute.flx && touch /tmp/.kino_suche.ok || rm /tmp/kino_heute.flx
			fi
		else
			TEXT=1; fehler_info
		fi
		[ -e /tmp/kino_heute.htm ] && rm /tmp/kino_heute.htm
	;;
	NEUE)
		timeOut
		wget -q -O /tmp/kino_neu.htm "http://www.heutekino.de/index.php?section=neustarts"
		kill $!
		FEHLER=Kino-Neustarts
		if [ -s /tmp/kino_neu.htm ]; then
			echo "$FLEX_A~>MENU=Kino-Neustarts" | sed -e 's/~>/\n/g' > /tmp/kino_neu.flx
			sed -e '/Neustarts.*<\/b><\/div><br>[^ -~]*$/!d' /tmp/kino_neu.htm | sed -e '{s/<[^>]*>//g;y/'\''//;s/^ */COMMENT=~S/;s/ *$//}' >> /tmp/kino_neu.flx
			sed -e '/index.php?section=showfilm/!d' /tmp/kino_neu.htm | sed -e '{s/<tr><td>/\n/g;y/'\''//}' | sed -e '{1d;s|[^"]*.\([^"]*\)[^>]*>[^>]*>\([^<]*\).*align=.justify.>\([^<]*\).*|ACTION=\&'\''\2'\'','$0' FILM_N '\''\2\'\'' \"\1\" '\''\3'\''|}' >> /tmp/kino_neu.flx
			echo "COMMENT=*~>$FLEX_E" | sed -e 's/~>/\n/g' >> /tmp/kino_neu.flx
			if [ $(grep -c '^ACTION=' /tmp/kino_neu.flx) -le 0 ]; then
				fehler_info
			else
				shellexec /tmp/kino_neu.flx || rm /tmp/kino_neu.flx
			fi
		else
			TEXT=1; fehler_info
		fi
		[ -e /tmp/kino_neu.htm -o -e /tmp/kino_neu.flx ] && rm /tmp/kino_neu.*
	;;
	KINO)
		timeOut
		wget -q -O /tmp/kino_kino.htm "http://www.heutekino.de/$3"
		kill $!
		FEHLER=Kino-Information
		if [ -s /tmp/kino_kino.htm ]; then
			[ -e /var/etc/.kino_detail.off ] && DETAIL=dat || DETAIL=flx
			[ -e /tmp/kino_detail.dat -o -e /tmp/kino_detail.flx ] && rm /tmp/kino_detail.*
			KINO_N=`echo "$2" | sed -e 's/&/\\\&/'g`
			WOCHE=`sed -e '/Checkbox. name=.datum/!d' /tmp/kino_kino.htm | sed -n '{1p;$p}' | sed -e 's/.* \([^<]*\).*/\1/' | sed 'N;s/\n\(.*\)/.  -  \1./'`
			echo "$FLEX_A~>MENU=Kino-Information~>ACTION=&'$2  -  $4',$0 FAVO '$2' \"$3\" '$4'~>INCLUDE=/tmp/kino_detail.flx~>COMMENT=*~>COMMENT=Film~ubersicht der laufenden Programm-Woche   $WOCHE" | sed -e 's/~>/\n/g' > /tmp/kino_kino.flx
			sed -e '/^<div><b>.*<\/b><br>/!d' /tmp/kino_kino.htm | sed -e '{s/<br> <hr>[^ -~]//;s/<br>/\n/g}' | sed -e '{1d;s/<[^>]*>//g;y/'\''//;s/.*/COMMENT=~S&/g;s/&ouml;/~o/g;s/&auml;/~a/g;s/&uuml;/~u/g;s/&Ouml;/~O/g;s/&Auml;/~A/g;s/&Uuml;/~U/g;s/&szlig;/~z/g;/^COMMENT=~S$/d}' > /tmp/kino_detail.$DETAIL
			sed -e '/index.php?section=showfilm/!d' /tmp/kino_kino.htm | sed -e '{y/'\''//;s|\(index.php?section=showfilm[^"]*\).>\([^<]*\)|>\nACTION=\&'\''\2'\'','$0' PROG '\'"\2"\'' '\'"$KINO_N"\'' \"\1\"|g;s/<br>/_/g;s/<\/a>__/ '\''/g;s/ *&nbsp//g;s/<[^>]*>//g}' | sed -e 's/__[^ -~]*$/'\''/' | sed '/^$/d' >> /tmp/kino_kino.flx
			echo "COMMENT=*~>$FLEX_E" | sed -e 's/~>/\n/g' >> /tmp/kino_kino.flx
			if [ $(grep -c '^ACTION=' /tmp/kino_kino.flx) -le 0 ]; then
				fehler_info
				[ -e /tmp/kino_kino.flx ] && rm /tmp/kino_kino.flx
			else
				shellexec /tmp/kino_kino.flx || rm /tmp/kino_kino.flx
			fi
		else
			TEXT=1; fehler_info
		fi
		[ -e /tmp/kino_kino.htm ] && rm /tmp/kino_kino.htm
	;;
	PROG)
		TITEL="$2"; KINO_N="$3"; FILM_ID="$4"
		TITEL2=`echo "$2 " | sed -e 's/.\{,65\} /&\n~Y/g' | sed -e '{s/ *$//;/^~Y$/d}'`
		ZEITEN=`echo "$5" | sed -e '{s/_*$/\n~s/;s/_/\n/g;s/[ri]. /& /g;s/;/ ~t/g}'`
		[ -e /tmp/kino_detail.flx ] && DETAIL=flx || DETAIL=dat
		PHONE=`sed -n 's/^COMMENT=~S\([0-9/]\+\)$/~n~B~cKino-Telefon-Nr.: \1/p' /tmp/kino_detail.$DETAIL | sed -e '1!d'`
		prog_info() {
			msgbox size=31 default=${DEF_P:-1} absolute=1 select="EXIT, Film-Info ,Kino-Info" title="Programm-Information" msg="~Y$TITEL2~n~s~n$ZEITEN$PHONE"
			case $? in
				2)
					DEF_P=2
					film_info
					if [ "$SEL_T" != 1 ]; then
						DEF_T=1
						prog_info
					fi
				;;
				3)
					DEF_P=3
					kino_info
					msgbox size=32 timeout=300 title="Kino-Information" popup="$KINO_I~n~s$PHONE"
					prog_info
				;;
			esac
		}
		prog_info
	;;
	FILM)
		TITEL="$2"; FILM_ID="$3"
		film_info
	;;
	FILM_N)
		TITEL="$2"; FILM_ID="$3"
		K_INFO=`echo "$2 " | sed -e 's/.\{,65\} /&\n~Y/g' | sed 's/^~Y$/~s~n/'``echo "$4" | sed -e '{s/.\{,65\} /&\n/g}'`
		kurz_info() {
			msgbox size=29 default=${DEF_K:-1} absolute=1 select="EXIT,Film-Info, Film-Suche... " title="Kurz-Information" msg="~Y`echo "$K_INFO" | sed -e '{1,14!d;s/ *$//}'`~n~s"
			case $? in
				2)
					DEF_K=2
					film_info
					if [ "$SEL_T" != 1 ]; then
						DEF_T=1
						kurz_info
					fi
				;;
				3)
					DEF_K=3; STADT_A=1; STAEDTE=; ZEILE=0; ZEILEN=0
					[ -e /tmp/.kino_suche.ok ] && rm /tmp/.kino_suche.ok
					if [ -s /var/tuxbox/config/kino_suche.conf ]; then
						while [ -n "$STADT_A" -a "$ZEILEN" != 10 ]; do
							ZEILE=`expr $ZEILE + 1`
							STADT_A=`sed -e '/^ACTION=.*,/!d' /var/tuxbox/config/kino_suche.conf | sed -e '{'$ZEILE'!d;s/.*&startat=[^"]*.  *.\(.*\)./\1/;s/,//g}'`
							if [ -n "$STADT_A" -a $(echo "$STAEDTE" | grep -c ' '"$STADT_A"' ') = 0 ]; then
								ZEILEN=`expr $ZEILEN + 1`
								STAEDTE=`echo "$STAEDTE" | sed -e '{s/$/, '"$STADT_A"' /;1s/^,//;$s/, *$//}'`
							fi
						done
						if [ "$ZEILEN" != 0 ]; then
							WAHL=`msgbox size=32 default=${DEF_S:-1} absolute=1 echo=1 order=1 select="$STAEDTE, ~SStadt eingeben... ,~SEXIT" title="Film-Suche in ..." msg=`
							SEL_S=$?
							if [ "$SEL_S" != 0 -a "$WAHL" != "~SEXIT" ]; then
								DEF_S=$SEL_S
								STADT_N=`echo "$WAHL" | sed -e '{s/^ ~SStadt ein.*//;s/^ *//;s/ *$//}'`
								$0 SUCHE "$STADT_N" "$TITEL"
							fi
						fi
					fi
					if [ "$ZEILEN" = 0 ]; then
						$0 SUCHE "" "$TITEL"
					fi
					if [ "$WAHL" != "~SEXIT" -a ! -e /tmp/.kino_suche.ok ]; then
						kurz_info
					fi
				;;
			esac
		}
		kurz_info
	;;
	FAVO)
		KINO_N="$2"; kino_info
		if [ -e /var/etc/.kino_detail.off ]; then
			SET_INFO="~G Einblenden "; KINO_INFO=einblenden
		else
			DEL_INFO="~R Ausblenden "; KINO_INFO=ausblenden
		fi
		if [ -s /var/tuxbox/config/kino_suche.conf ]; then
			SKINO_ID=`echo "$3" | sed -e 's/.*&//'`
			grep -q "$SKINO_ID\"" /var/tuxbox/config/kino_suche.conf > /dev/null
			if [ $? = 1 ]; then
				SET_FAVO="~G Hinzuf~ugen "; KINO_SET="Zu der Favoriten-Liste hinzuf~ugen"
			else
				DEL_FAVO="~R Entfernen "; KINO_SET="Von der Favoriten-Liste entfernen"
			fi
		else
			SET_FAVO="~G Hinzuf~ugen "; KINO_SET="Zu der Favoriten-Liste hinzuf~ugen"
		fi
		msgbox size=32 absolute=1 select="EXIT,$SET_INFO,$DEL_INFO,$SET_FAVO,$DEL_FAVO" title="Kino-Einstellungen" msg="$KINO_I~n~s~n~cKinodetails in der ~Ubersicht $KINO_INFO ?~n~c$KINO_SET ?"
		case $? in
			2)
				rm /var/etc/.kino_detail.off
				mv /tmp/kino_detail.dat /tmp/kino_detail.flx
			;;
			3)
				touch /var/etc/.kino_detail.off
				mv /tmp/kino_detail.flx /tmp/kino_detail.dat
			;;
			4)
				echo "ACTION=&'$2  -  $4',$0 KINO '$2' \"$3\" '$4'" >> /var/tuxbox/config/kino_suche.conf
			;;
			5)
				FAVO_CONF=`cat /var/tuxbox/config/kino_suche.conf`
				echo "$FAVO_CONF" | sed '/'$SKINO_ID'/d' > /var/tuxbox/config/kino_suche.conf
				[ -s /var/tuxbox/config/kino_suche.conf ] || rm /var/tuxbox/config/kino_suche.conf
			;;
		esac
	;;
esac
exit 0
